source: BOL/script_install_amaury/install_lmdz.sh @ 4900

Last change on this file since 4900 was 4900, checked in by abarral, 5 weeks ago

change bundled veget version
fix veget version update
unbundle XIOS
split init and install arch
fix ORCHIDEE XIOS library forwarding
fix local netcdf compil
fix Makefile linking

  • Property svn:executable set to *
File size: 30.6 KB
Line 
1#!/bin/bash
2set -eu  # error on command failure, and on unset variables
3export LC_ALL=# standardize awk format
4
5###########################################################################
6# Author : Laurent Fairhead et Frédéric Hourdin
7# Usage  : install_lmdz.sh -help
8#
9# bash installation script of the LMDZ model on different computer types :
10# Linux PC, "mesocentre" (IPSL-UPMC, IPSL-X), super-computer (IDRIS)
11#
12# The model is downloaded in the following directory tree
13# $MODEL/modipsl/modeles/...
14# using the "modipsl" infrastructure created by the "IPSL"
15# for coupled (atmosphere/ocean/vegetation/chemistry) climate modeling
16# activities.
17# Here we only download atmospheric (LMDZ) and vegetation (ORCHIDEE)
18# components.
19#
20# The sources of the models can be found in the "modeles" directory.
21# In the present case, LMDZ, ORCHIDEE, and IOIPSL or XIOS (handling of
22# input-outputs using the NetCDF library).
23#
24# The script downloads various source files (including a version of NetCDF)
25# and utilities, compiles the model, and runs a test simulation in a
26# minimal configuration.
27#
28# Prerequisites : pgf90/gfortran, bash or ksh, wget , gunzip, tar, ...
29#
30# Modif 18/11/2011
31#    changes for option real 8.
32#      We compile with -r8 (or equivalent) and -DNC_DOUBLE for the GCM
33#      but with -r4 for netcdf. Variable real must be set to
34#      r4 or r8 at the beginning of the script below.
35#
36###########################################################################
37
38### Functions
39
40function myget { # Get a file from LMDZ repository
41  local url=$1
42
43  local filename
44  filename=$(basename "$url")
45
46  wget --no-check-certificate -nv "http://lmdz.lmd.jussieu.fr/pub/$url"
47  if [[ $filename =~ .*\.(ba)?sh ]]; then chmod +x "$filename"; fi
48}
49
50function set_default_params {
51    # Valeur par défaut des parametres
52    svn=""
53    version="20231022.trunk"
54
55    netcdf=1
56    bench=1
57    pcmac=0 # default: not on a Mac
58    SCM=0
59    veget="none"
60    grid_resolution="32x32x39"
61    physiq=""
62
63    xios_branch="2.6"
64    xios_rev="2568"
65
66    parallel="none"
67    trusting="testing"
68    MODEL=""
69
70    with_xios=0
71    opt_makelmdz_xios=""
72
73    rad="rrtm"
74
75    compile_with_fcm=1
76
77    cosp="none"
78    opt_cosp=""
79
80    make_j=8
81
82    # Check if on a Mac
83    if [[ $(uname) = "Darwin" ]]; then
84        pcmac=1
85        export MAKE="make"
86    fi
87
88    optim_debug=""
89    arch="local"
90
91    local mpi_file
92    mpi_file=$(readlink -f "$(which mpif90)")
93    path_mpi=$(dirname "$mpi_file")
94    root_mpi=$(dirname "$path_mpi")
95
96    arch="local-gfortran"
97    arch_dir=""
98}
99
100function read_cmdline_args {
101    while (($# > 0)); do
102        case $1 in
103            "-h") cat <<........fin
104        $0 [ -v version ] [ -r svn_release ]
105               [ -parallel PARA ] [ -d GRID_RESOLUTION ] [ -bench 0/1 ]
106               [-name LOCAL_MODEL_NAME] [-gprof] [-opt_makelmdz] [-rad RADIATIF]
107
108        -v       "version" like 20150828.trunk, see http://www.lmd.jussieu.fr/~lmdz/Distrib/LISMOI.trunk (default <$version>)
109
110        -r       "svn_release" : either the svn release number or "last" (default <$svn>)
111
112        -parallel parallel support: mpi, omp, mpi_omp (mpi with openMP) or none (default: <$parallel>)
113
114        -d        "grid resolution": should be among the available benchs if -bench 1 (valid values: 48x36x19, 48x36x39) (default : <$grid_resolution>)
115
116        -bench     activating the bench or not (0/1) (default: <$bench>)
117
118        -testing/unstable
119
120        -name      name of the folder to install to (default <$MODEL>)
121
122        -netcdf    0, 1 or PATH. 0: do not download NetCDF, look for it in standard locations (/usr);  1: download and compile NetCDF; PATH: full path to an existing installed NetCDF library (default: <$netcdf>)
123
124        -xios      use (download and compile) the XIOS library (will compile the parallel NetCDF4-HDF5 library) (requires to also have -parallel mpi_omp)
125
126        -cosp       to run with cospv1 or cospv2 [none/v1/v2] (default <$cosp>)
127
128        -rad        radiative code: oldrad, rrtm or ecrad (default <$rad>)
129
130        -nofcm      to compile without fcm
131
132        -SCM        install 1D version automatically
133
134        -debug      compile everything in debug mode
135
136        -physiq     to choose which physics package to use (default <$physiq>)
137
138        -veget      surface/vegetation scheme treatment controlled by the single variable veget which can have the following values: none: bucket scheme (default); CMIP6 | veget2.0: orchidee version used in CMIP exercise, rev 5661; veget2.2: orchidee branch 2.2, rev 8529 (bundled); number: orchidee version number (default $veget)
139
140        -arch       name of the arch to use (default <$arch>)
141
142        -arch_dir   where to find the arch files (default <$arch_dir>)
143
144        -make_j     number of processes to parallelize installations (default <$make_j>)
145
146........fin
147                  exit 1;;
148            "-v") version=$2; shift; shift;;
149            "-r") svn=$2; shift; shift;;
150            "-d") grid_resolution=$2; shift; shift;;
151            "-unstable"|"-testing") trusting=$(echo "$1" | cut -c2-); shift;;
152            "-cosp") cosp=$2
153                     case $cosp in
154                         "none"|"v1"|"v2") cosp=$2; shift; shift;;
155                         *) echo "Only none v1 v2 for cosp option"; exit 1
156                     esac;;
157            "-nofcm") compile_with_fcm=0; echo "This option will be reactivated soon (promesse du 8dec2022)"; exit 1;  shift;;
158            "-SCM") SCM=1; shift;;
159            "-rad") rad=$2
160                    case $rad in
161                        "oldrad"|"rrtm"|"ecrad") rad=$2; shift; shift;;
162                        *) echo "Only oldrad rrtm ecrad for rad option"; exit 1
163                    esac;;
164            "-parallel") parallel=$2
165                         case $parallel in
166                             "none"|"mpi"|"omp"|"mpi_omp") parallel=$2; shift; shift;;
167                             *) echo "Only none mpi omp mpi_omp for the parallel option"; exit 1
168                         esac;;
169            "-bench") bench=$2; shift; shift;;
170            "-debug") optim_debug=-debug; shift;;
171            "-name") MODEL=$2; shift; shift;;
172            "-netcdf") netcdf=$2; shift; shift;;
173            "-physiq") physiq=$2; shift; shift;;
174            "-xios") with_xios=1; shift;;
175            "-arch") arch=$2; shift; shift;;
176            "-arch_dir") arch_dir=$2; shift; shift;;
177            "-veget") veget=$2; shift; shift;;
178            "-make_j") make_j=$2; shift; shift;;
179            *)  bash install_lmdz.sh -h; exit 1
180        esac
181    done
182
183    # Option de compilation pour Cosp
184    case $cosp in
185        v1) opt_cosp="-cosp true";;
186        v2) opt_cosp="-cospv2 true";;
187        *) opt_cosp=""
188    esac
189
190    # Check on veget version
191    if [[ $veget != 'none' && $veget != "CMIP6" && $veget != "orch2.0" && $veget != "orch2.2" ]]; then
192        re='^[0-9]+$'
193        if ! [[ $veget =~ $re ]]; then
194            echo 'Valeur de l option veget non valable'; exit 1
195        fi
196    fi
197
198    #Define veget-related suffix for gcm name
199    if [[ $veget = 'none' ]]; then
200        suff_orc=''
201    else
202        suff_orc='_orch'
203    fi
204
205
206    if [[ $parallel = "none" ]]; then
207        suff_exe='_seq'
208    else
209        suff_exe='_para_mem'
210    fi
211
212    #Chemin pour placer le modele
213    if [[ $MODEL = "" ]]; then MODEL="./LMDZ$version$svn$optim_debug"; fi
214
215    ## if also compiling XIOS, parallel must be mpi_omp
216    if [[ $with_xios = 1 && $parallel != "mpi_omp" ]]; then
217        echo "Error, you must set -parallel mpi_omp if you want XIOS"; exit 1
218    fi
219
220    if [[ $with_xios = 1 ]]; then
221        opt_makelmdz_xios="-io xios"
222    fi
223
224    if [[ $cosp = "v2" && $with_xios = 0 ]]; then
225        echo "Error, Cospv2 cannot run without Xios"; exit 1
226    fi
227
228    if [[ $arch_dir = "" ]]; then
229        arch_dir="$MODEL/modipsl/config/IPSLCM7/ARCH/"
230    fi
231    arch_dir=$(readlink -f "$arch_dir")  # full path
232}
233
234function check_available_software {
235    echo "################################################################"
236    echo "Check if required software is available"
237    echo "################################################################"
238    for logiciel in wget tar gzip make gcc cmake m4 c++; do
239        if [[ $(which "$logiciel") = "" ]]; then
240            echo "You must first install $logiciel on your system"; exit 1
241        fi
242    done
243
244    cat <<eod > tt.f90
245print*,'coucou'
246end
247eod
248    $compiler tt.f90 || a.out
249    ./a.out >| tt
250    if [[ $(< tt sed -e 's/ //g' ) != "coucou" ]]; then
251        echo "problem installing with compiler $compiler"; exit 1
252    fi
253    \rm tt a.out tt.f90
254}
255
256function download_model {
257    mkdir -p "$MODEL"
258    MODEL=$(readlink -f "$MODEL"); echo "$MODEL"  # absolute path
259
260    rm -rf "$MODEL/modipsl"
261
262    echo "##########################################################"
263    echo "Download a slightly modified version of  LMDZ"
264    echo "##########################################################"
265    cd "$MODEL"
266    getlog="$(pwd)/get.log"
267    echo "logfile : $getlog"
268    myget "src_archives/$trusting/modipsl.$version.tar.gz" >> get.log 2>&1
269    echo "install_lmdz.sh wget_OK $(date)"
270    gunzip "modipsl.$version.tar.gz" >> get.log 2>&1
271    tar xf "modipsl.$version.tar" >> get.log 2>&1
272    \rm "modipsl.$version.tar"
273
274    if [[ $svn != "" ]]; then
275        mysvn=$svn
276    else
277        mysvn="$(grep 'Revision: [0-9]' "$MODEL"/Read*.md | awk ' { print $2 } ' 2>/dev/null)"
278    fi
279    echo "SVN revision used: $mysvn"
280}
281
282function download_model_AMAURY {  # TODO TEMP while waiting for tar: we copy the base from a local path = IPSLCM7 + ORCH2.2 latest
283    if [[ ! -d ../MODEL_REF ]]; then
284        cd ..
285        mkdir MODEL_REF
286        cd MODEL_REF
287        svn co --username icmc_users https://forge.ipsl.fr/igcmg/svn/modipsl/trunk modipsl
288        cd modipsl/util
289        ./model IPSLCM7_work
290        rm -rf oasis3-mct
291        cd ../modeles
292        rm -rf ICOSA_LMDZ ORCHIDEE_4 ORCHIDEE_2_2 NEMO DYNAMICO XIOS INCA
293        svn co svn://forge.ipsl.fr/orchidee/branches/ORCHIDEE_2_2/ORCHIDEE
294        cd ../../../script_install
295    fi
296
297    if [[ ! -d "$MODEL" ]]; then
298        \cp -r ../MODEL_REF .
299        mv MODEL_REF "$MODEL"
300    fi
301    MODEL=$(readlink -f "$MODEL"); echo "$MODEL"  # absolute path
302
303    if [[ $svn != "" ]]; then
304        mysvn=$svn
305    else
306        mysvn="$(grep 'Revision: [0-9]' "$MODEL"/Read*.md | awk ' { print $2 } ' 2>/dev/null)"
307    fi
308    echo "SVN revision used: $mysvn"
309}
310
311function init_arch {
312    if [[ ! -d $arch_dir ]]; then
313        echo "Error: no arch dir $arch_dir"; exit 1
314    elif [[ ! -f $arch_dir/arch-$arch.path ]]; then
315        echo "Error: no arch-$arch.path in $arch_dir"; exit 1
316    fi
317
318    local fcm_path
319    if [[ -f $arch_dir/arch-$arch.fcm ]]; then
320        fcm_path="$arch_dir/arch-$arch.fcm"
321    else
322        fcm_path="$MODEL/modipsl/modeles/LMDZ/arch/arch-$arch.fcm"
323        if [[ ! -f $fcm_path ]]; then
324            echo "Error: no $fcm_path"; exit 1
325        fi
326    fi
327
328    # check compiler
329    compiler=$(< "$fcm_path" grep "%COMPILER" | sed -e "s/%COMPILER\s*//")
330}
331
332function install_arch {
333    local component=$1
334
335    if [[ ! -f "$MODEL/modipsl/modeles/$component/arch/arch-$arch.fcm" ]]; then
336        \cp -f "$arch_dir/arch-$arch.fcm" "$MODEL/modipsl/modeles/$component/arch"
337        \cp -f "$arch_dir/arch-$arch.path" "$MODEL/modipsl/modeles/$component/arch"
338
339        if [[ $component = "XIOS" ]]; then
340            # Adapt for XIOS, which uses different naming conventions
341            sed -i'' -e "s/%COMPILER/%FCOMPILER/" -e "s/%LINK/%LINKER/" -e "s/-fdefault-real-8//" "$MODEL/modipsl/modeles/XIOS/arch/arch-$arch.fcm"
342        elif [[ $component = "ORCHIDEE" ]]; then
343            if [[ $orcbranch = "/tags/ORCHIDEE_2_0/ORCHIDEE" ]]; then  # 2.0 and before have a different fcm convention
344                sed -i'' -e "s/-I//" -e "s/-L//" "$MODEL/modipsl/modeles/ORCHIDEE/arch/arch-$arch.path"  # /!\ we only replace first occurence on purpose
345            fi
346        fi
347    fi
348}
349
350function install_netcdf {
351    echo "Installing Netcdf"
352    local ncdf_compiler="$compiler"
353
354    if [[ $netcdf = 0 ]]; then
355        ncdfdir=$(nc-config --prefix)
356    else
357        cd "$MODEL"
358
359        # Convert non-basic compiler
360        case $compiler in  # TODO check if it works with other base compilers
361            mpif90) ncdf_compiler=$($compiler --help | head -n 1 | cut -f 2 -d " ")
362        esac
363
364        case $ncdf_compiler in
365            gfortran) opt1="-compiler gnu"; opt2="-CC gcc -FC gfortran -CXX g++";;
366            ifort)  opt1="-compiler intel"; opt2="-CC icc -FC ifort -CXX icpc";;
367            pgf90)  opt1="-compiler pgf90"; opt2="-CC pgcc -FC pgf90 -CXX pgCC";;
368            *)      echo "unexpected compiler $ncdf_compiler for netcdf"; exit 1
369        esac
370
371        case $with_xios in
372            0) script_install_netcdf="install_netcdf4_hdf5_seq.bash"
373               ncdfdir="netcdf4_hdf5_seq"
374               opt_="$opt1";;
375            1) script_install_netcdf="install_netcdf4_hdf5.bash"
376               ncdfdir="netcdf4_hdf5"
377               opt_="$opt2 -MPI $root_mpi";;
378            *) echo "with_xios=$with_xios, should be 0 or 1"; exit 1
379        esac
380        if [[ $netcdf = 1 ]]; then
381           ncdfdir="$MODEL/$ncdfdir"
382        else
383           mkdir -p "$netcdf"; ncdfdir="$netcdf/$ncdfdir"
384        fi
385
386        echo "Repertoire netcdf $ncdfdir"
387        if [[ ! -d $ncdfdir ]]; then
388            netcdflog=$(pwd)/netcdf.log
389            echo "----------------------------------------------------------"
390            echo "Compiling the Netcdf library"
391            echo "----------------------------------------------------------"
392            echo "log file : $netcdflog"
393            myget script_install/$script_install_netcdf >> "$netcdflog" 2>&1
394            chmod u=rwx $script_install_netcdf
395            # shellcheck disable=SC2086
396            ./$script_install_netcdf -prefix "$ncdfdir" $opt_ >> "$netcdflog" 2>&1
397        fi
398
399        # Add to path
400        export PATH="$ncdfdir/bin:$PATH"
401
402        #----------------------------------------------------------------------------
403        # LF rajout d'une verrue, pour une raison non encore expliquee,
404        # la librairie est parfois rangée dans lib64 et non dans lib
405        # par certains compilateurs
406        if [[ ! -e lib && -d lib64 ]]; then ln -s lib64 lib; fi
407        #----------------------------------------------------------------------------
408
409        echo "install_lmdz.sh netcdf_OK $(date)"
410    fi
411
412    cat >test_netcdf90.f90 <<EOF
413    use netcdf
414    print *, "NetCDF library version: ", nf90_inq_libvers()
415    end
416EOF
417
418    if $ncdf_compiler -I"$ncdfdir"/include test_netcdf90.f90 -L"$ncdfdir"/lib -lnetcdff \
419              -lnetcdf -Wl,-rpath="$ncdfdir"/lib && ./a.out
420    then
421        \rm test_netcdf90.f90 a.out
422    else
423        cat <<EOF
424Failed test program using NetCDF-Fortran. You can:
425- check that you have NetCDF-Fortran installed in your system
426- or specify an installation directory with option -netcdf of install_lmdz.sh
427- or download and compile NetCDF-Fortran with option -netcdf 1 of nstall_lmdz.sh
428EOF
429        exit 1
430    fi
431
432    # Compile NetCDF95
433    cd "$MODEL/modipsl/modeles/LMD"*
434    echo "Installing NetCDF95"
435    cd "$MODEL"
436    myget src_archives/netcdf/NetCDF95-0.3.tar.gz
437    tar -xf NetCDF95-0.3.tar.gz
438    \rm NetCDF95-0.3.tar.gz
439    cd NetCDF95-0.3
440    mkdir -p build && cd build
441    netCDF_INCLUDE_DIR=$(nc-config --includedir) netCDF_LIBRARY=$(nc-config --libdir) cmake .. -DCMAKE_BUILD_TYPE=Release -DCMAKE_PREFIX_PATH="$ncdfdir" -DCMAKE_INSTALL_PREFIX="$MODEL/modipsl"
442    make install
443}
444
445function install_IOIPSL {
446    install_arch "IOIPSL"
447
448    cd "$MODEL/modipsl/modeles/IOIPSL"
449    ioipsllog="$(pwd)/ioipsl.log"
450    echo "Compiling IOIPSL, the interface library with Netcdf $(date) (log: $ioipsllog)"
451
452    if ! ./makeioipsl_fcm -arch "$arch" -job 8 > "$ioipsllog" 2>&1; then
453        echo "IOIPSL compile failed, exiting"; exit 1
454    fi
455
456    # Link to modipsl/bin
457    cp -f bin/* ../../bin
458
459    echo "IOIPSL compiled $(date)"
460
461    IOIPSL_LIBDIR_="$MODEL/modipsl/modeles/IOIPSL/lib"
462    IOIPSL_INCDIR_="$MODEL/modipsl/modeles/IOIPSL/inc"
463}
464
465function install_XIOS {
466    if [[ $with_xios = 1 ]]; then
467        cd "$MODEL/modipsl/modeles"
468        xioslog="$(pwd)/XIOS/xios.log"
469        echo "##########################################################"
470        echo "Compiling XIOS (log $xioslog) $(date)"
471        echo "##########################################################"
472
473        # Download XIOS
474        case $xios_branch in
475            "trunk")
476            xios_http="http://forge.ipsl.jussieu.fr/ioserver/svn/XIOS/trunk";;
477            "2.5")
478            xios_http="http://forge.ipsl.jussieu.fr/ioserver/svn/XIOS/branchs/xios-2.5";;
479            "2.6")
480            xios_http="http://forge.ipsl.jussieu.fr/ioserver/svn/XIOS2/branches/xios-2.6";;
481            *) echo "XIOS: Error, bad argument for -branch ! Did not expect $xios_branch"; exit;;
482        esac
483       
484        cd "$MODEL/modipsl/modeles"
485        set +e; svn co --revision $xios_rev $xios_http XIOS; set -e
486
487        cd XIOS
488
489        install_arch "XIOS"
490
491        echo "Starting XIOS compilation"
492        if ! ./make_xios --arch "$arch" --job 8 > "$xioslog" 2>&1; then
493            echo "XIOS compilation failed, exiting"; exit 1
494        fi
495
496        echo "Compiled XIOS $(date)"
497    fi
498
499    XIOS_LIBDIR_="$MODEL/modipsl/modeles/XIOS/lib"
500    XIOS_INCDIR_="$MODEL/modipsl/modeles/XIOS/inc"
501}
502
503function get_orchidee_version {  # Set / Check ORCHIDEE version
504    local fetch_rev=""
505    orcbranch=""
506    case $veget in
507        "none") fcm_veget_version="false";;
508        "orch2.0" | "CMIP6") fcm_veget_version=orchidee2.0; fetch_rev=6592;;
509        "orch2.2") fcm_veget_version=orchidee2.1; orcbranch="ORCHIDEE_2_2" ;; # the bundled version
510        *) fetch_rev=$veget
511    esac
512
513    if [[ -n $fetch_rev ]]; then
514        echo "Fetching orch $fetch_rev from the repository"
515        orcbranch=$(svn log -v -q svn://forge.ipsl.jussieu.fr/orchidee/ -r "$fetch_rev" |grep ORCHIDEE |head -1| sed -e 's:ORCHIDEE/.*$:ORCHIDEE:' | awk '{print $2}')
516        echo "branch is $orcbranch"
517        if [[ $fetch_rev -lt 4465 ]]; then echo 'ORCHIDEE version must be >=4465, exiting'; exit 1; fi
518        \rm -rf "$MODEL/modipsl/modeles/ORCHIDEE"
519        echo "IF YOU INSTALL ORCHIDEE THE VERY FIRST TIME, ASK for PASSWORD at orchidee-help@listes.ipsl.fr"
520        cd "$MODEL/modipsl/modeles"
521        set +e
522        svn co -r "$fetch_rev" "svn://forge.ipsl.jussieu.fr/orchidee/$orcbranch"
523        set -e
524        cd -
525    fi
526}
527
528function compile_orchidee {
529    get_orchidee_version
530    install_arch "ORCHIDEE"
531
532    ORCHPATH=""
533
534
535    if [[ $veget != "none" ]]; then
536        cd "$MODEL/modipsl/modeles/ORCHIDEE"
537        ORCHPATH=$(pwd)
538
539        orchideelog="$(pwd)/orchidee.log"
540        echo "Compiling ORCHIDEE, the continental surface model (log $orchideelog) $(date)"
541
542        local xios_orchid opt_orc
543        if [[ $with_xios = 1 ]]; then
544            xios_orchid="-xios";
545        else
546            xios_orchid="-noxios"
547        fi
548        if [[ $optim_debug = "-debug" ]]; then
549            opt_orc="-debug";
550        else
551            opt_orc="-prod"
552        fi
553
554        local varenv="IOIPSL_LIBDIR_=$IOIPSL_LIBDIR_ IOIPSL_INCDIR_=$IOIPSL_INCDIR_ ORCHPATH=$ORCHPATH XIOS_INCDIR_=$XIOS_INCDIR_ XIOS_LIBDIR_=$XIOS_LIBDIR_"
555        if [[ $parallel = "none" ]]; then
556            echo "$varenv ./makeorchidee_fcm $xios_orchid $opt_orc -parallel none -arch $arch -j $make_j" > compile.sh
557        else
558            if [[ ! -d src_parallel ]]; then
559               echo "Orchidee version too old for parallel support"; exit 1
560            fi
561            {
562                echo "$varenv ./makeorchidee_fcm -j $make_j -clean $xios_orchid $opt_orc -parallel $parallel -arch $arch"
563                echo "$varenv ./makeorchidee_fcm -j $make_j $xios_orchid $opt_orc -parallel $parallel -arch $arch"
564            } > compile.sh
565        fi
566        chmod +x compile.sh
567        echo "Compiling ORCHIDEE using $(\cat compile.sh)"
568        if ! ./compile.sh > "$orchideelog" 2>&1; then
569            echo "ORCHIDEE compilation failed, exiting"; exit 1
570        fi
571        echo "Compiled ORCHIDEE $(date)"
572    fi
573
574    ORCH_LIBDIR_="$MODEL/modipsl/modeles/ORCHIDEE/lib"
575}
576
577function get_lmdz_version {
578    LMDZPATH=$(readlink -f "$MODEL/modipsl/modeles/LMD"*)
579    cd "$LMDZPATH"
580    lmdzlog="$(pwd)/lmdz.log"
581
582    set +e
583    svn upgrade
584    if [[ $svn = "last" ]]; then
585        svnopt=""
586    else
587        svnopt="-r $svn"
588    fi
589    if [[ $svn != "" ]]; then
590        if svn info | grep -q 'https:'; then svn switch --relocate https://svn.lmd.jussieu.fr/LMDZ http://svn.lmd.jussieu.fr/LMDZ; fi
591        svn update "$svnopt"
592    fi
593    mysvn=$(svnversion . | grep -E -o "[0-9]+" 2>/dev/null)
594    set -e
595
596    if [[ $mysvn = "" ]]; then mysvn=$(grep 'Revision: [0-9]' "$MODEL"/Read*.md | awk ' { print $2 } ' 2>/dev/null); fi
597    if [[ $mysvn = "" ]]; then mysvn=4190; fi
598}
599
600function compile_lmdz {
601    get_lmdz_version
602    install_arch "LMDZ"
603
604    exe_name="bin/gcm_${grid_resolution}_phylmd_${rad}${suff_exe}${suff_orc}.e"
605
606    local opt_rad
607    case $rad in
608        oldrad) iflag_rrtm=0; NSW=2; opt_rad="";;
609        rrtm)   iflag_rrtm=1; NSW=6
610            if [[ $mysvn -le 4185 ]]; then
611                opt_rad="-rrtm true"
612            else
613                opt_rad="-rad rrtm"
614            fi;;
615        ecrad)  iflag_rrtm=2; NSW=6; opt_rad="-rad ecrad";;
616        *) echo "Only oldrad rrtm ecrad for rad option"; exit 1
617    esac
618    if [[ $mysvn -le 4185 && $rad = "ecrad" ]]; then
619        echo "ecrad only available for LMDZ rev starting with 4186 "; exit 1
620    fi
621
622    # Compile
623    local varenv="IOIPSL_LIBDIR_=$IOIPSL_LIBDIR_ IOIPSL_INCDIR_=$IOIPSL_INCDIR_ ORCH_LIBDIR_=$ORCH_LIBDIR_ ORCHPATH=$ORCHPATH XIOS_INCDIR_=$XIOS_INCDIR_ XIOS_LIBDIR_=$XIOS_LIBDIR_"
624    makelmdz="makelmdz_fcm $optim_debug -arch $arch -j $make_j"
625    if [[ $parallel = "none" ]]; then
626        echo "$varenv ./$makelmdz $opt_rad $opt_cosp -d ${grid_resolution} -v $fcm_veget_version gcm " > compile.sh
627    else
628        echo "$varenv ./$makelmdz $opt_rad $opt_cosp $opt_makelmdz_xios -d ${grid_resolution} -v $fcm_veget_version -mem -parallel $parallel gcm" > compile.sh
629    fi
630    echo "Compiling lmdz using $(\cat compile.sh) (log: $lmdzlog) $(date)"
631    chmod +x ./compile.sh
632    if ! ./compile.sh > "$lmdzlog" 2>&1; then
633        echo "LMDZ compilation failed, exiting"; exit 1
634    fi
635    echo "Finished LMDZ compilation $(date)"
636
637    # Check executable
638    # TODO $mysev -ge 4186 => other name convention ! check original install
639    if [[ ! -f $exe_name ]]; then
640        echo "Compilation failed, can't find the executable"; exit 1
641    else
642        echo "Compilation successfull, the executable is $exe_name $(date)"
643    fi
644}
645
646function run_bench {
647    cd "$MODEL/modipsl/modeles/LMDZ"*
648
649    if [[ $bench = "tuto" ]]; then
650        myget "Training/tutorial.tar"; tar xf tutorial.tar; cd TUTORIAL
651        ./init.sh
652    elif [[ $bench = 1 ]]; then
653        \rm -rf "BENCH${grid_resolution}"
654        local bench=bench_lmdz_${grid_resolution}
655        myget "3DBenchs/$bench.tar.gz"
656        tar xf "$bench.tar.gz"
657
658        if [[ $cosp = "v1" || $cosp = "v2" ]]; then
659            cd "BENCH${grid_resolution}"
660            # copier les fichiers namelist input et output our COSP
661            cp ../DefLists/cosp*_input_nl.txt .
662            cp ../DefLists/cosp*_output_nl.txt .
663            # Activer la cles ok_cosp pour tourner avec COSP
664            sed -e 's@ok_cosp=n@ok_cosp=y@' config.def > tmp
665            \mv -f tmp config.def
666            cd ..
667        fi
668
669        if [[ -n "$physiq" ]]; then
670            cd "BENCH${grid_resolution}"
671            if [[ -f "physiq.def_${physiq}" ]]; then
672                cp "physiq.def_${physiq}" physiq.def
673                echo "using physiq.def_${physiq}"
674            else
675                echo "using standard physiq.def"
676            fi
677            cd ..
678        else
679            echo "using standard physiq.def"
680        fi
681
682        if [[ $with_xios = 1 ]]; then
683            cd "BENCH${grid_resolution}"
684            cp ../DefLists/iodef.xml .
685            cp ../DefLists/context_lmdz.xml .
686            cp ../DefLists/field_def_lmdz.xml .
687            # A raffiner par la suite
688            echo "A FAIRE : Copier les *xml en fonction de l option cosp"
689            cp ../DefLists/field_def_cosp*.xml .
690            cp ../DefLists/file_def_hist*xml .
691            # adapt iodef.xml to use attached mode
692            sed -e 's@"using_server" type="bool">true@"using_server" type="bool">false@' \
693                iodef.xml > tmp
694            \mv -f tmp iodef.xml
695
696            # and convert all the enabled="_AUTO_" (for libIGCM) to enabled=.FALSE.
697            # except for histday
698            for histfile in file_def_hist*xml
699            do
700                if [[ "$histfile" = "file_def_histday_lmdz.xml" ]]; then
701                    sed -e 's@enabled="_AUTO_"@type="one_file" enabled=".TRUE."@' \
702                        "$histfile" > tmp
703                    \mv -f tmp "$histfile"
704                    sed -e 's@output_level="_AUTO_"@output_level="5"@' "$histfile" \
705                        > tmp
706                    \mv -f tmp "$histfile"
707                    sed -e 's@compression_level="2"@compression_level="0"@' \
708                        "$histfile" > tmp
709                    \mv -f tmp "$histfile"
710                else
711                    sed -e 's@enabled="_AUTO_"@type="one_file" enabled=".FALSE."@' \
712                        "$histfile" > tmp
713                    \mv -f tmp "$histfile"
714                fi
715            done
716            # and add option "ok_all_xml=y" in config.def
717            echo "### XIOS outputs" >> config.def
718            echo 'ok_all_xml=.true.' >> config.def
719
720            #activer les sorties pour Cosp
721            if [[ "$cosp" = "v1" ]]; then
722                sed -i'' -e 's@enabled=".FALSE."@enabled=".TRUE."@' \
723                         -e 's@output_level="_AUTO_"@output_level="5"@' \
724                         -e 's@compression_level="2"@compression_level="0"@' \
725                         file_def_histdayCOSP_lmdz.xml
726            fi
727            if [[ "$cosp" = "v2" ]]; then
728                sed -e 's@compression_level="2"@compression_level="0"@' file_def_histdayCOSPv2_lmdz.xml
729                for type_ in hf day mth; do
730                    file=file_def_hist${type_}COSP
731                    sed -i'' -e 's@src="./'${file}'_lmdz.xml"@src="./'${file}'v2_lmdz.xml"@' context_lmdz.xml
732                done
733                sed -i '' -e 's@field_def_cosp1.xml@field_def_cospv2.xml@' field_def_lmdz.xml
734            fi
735
736            cd ..
737        fi
738
739        # Cas Bench avec ecrad
740        if [[ $rad = "ecrad" ]]; then
741            cd "BENCH${grid_resolution}"
742            cp  ../DefLists/namelist_ecrad .
743            cp -r ../libf/phylmd/ecrad/data .
744            cd ..
745        fi
746
747        # Adjusting bench physiq.def to radiative code chosen
748        cd "BENCH${grid_resolution}"
749        sed -e 's/iflag_rrtm=.*.$/iflag_rrtm='$iflag_rrtm'/' \
750            -e 's/NSW=.*.$/NSW='$NSW'/' physiq.def > tmpdef
751        \mv tmpdef physiq.def
752        cd ..
753
754        cp "$exe_name" "BENCH${grid_resolution}/gcm.e"
755        cd "BENCH${grid_resolution}"
756
757        if [[ ${parallel:0:3} = "mpi" ]]; then
758            # Lancement avec deux procs mpi et 2 openMP
759            echo "export OMP_STACKSIZE=800M" > bench.sh
760            if [[ "${parallel:4:3}" = "omp" ]]; then
761                echo "export OMP_NUM_THREADS=2" >> bench.sh
762            fi
763            if [[ "$cosp" = "v1" || "$cosp" = "v2" ]]; then
764                echo "ulimit -s 200000" >> bench.sh
765            else
766                echo "ulimit -s unlimited" >> bench.sh
767            fi
768            echo "mpirun -np 2 gcm.e > listing  2>&1" >> bench.sh
769            # Add rebuild, using reb.sh if it is there
770            cat <<EOF >> bench.sh
771    if [[ -f reb.sh ]]; then
772      ./reb.sh histday; ./reb.sh histmth; ./reb.sh histhf;
773      ./reb.sh histins; ./reb.sh stomate_history;
774      ./reb.sh sechiba_history; ./reb.sh sechiba_out_2
775    fi
776EOF
777        else
778            echo "./gcm.e > listing  2>&1" > bench.sh
779        fi
780        # Getting orchidee stuff
781        if [[ $veget = 'CMIP6' ]]; then
782            echo 'myget 3DBenchs/BENCHCMIP6.tar.gz'
783            myget 3DBenchs/BENCHCMIP6.tar.gz
784            tar xvzf BENCHCMIP6.tar.gz
785            sed -e "s:VEGET=n:VEGET=y:" config.def > tmp
786            mv -f tmp config.def
787            if [[ $with_xios = 1 ]]; then
788                cp ../../ORCHIDEE/src_xml/context_orchidee.xml .
789                echo '<context id="orchidee" src="./context_orchidee.xml"/>' > add.tmp
790                cp ../../ORCHIDEE/src_xml/field_def_orchidee.xml .
791                cp ../../ORCHIDEE/src_xml/file_def_orchidee.xml .
792                cp ../../ORCHIDEE/src_xml/file_def_input_orchidee.xml .
793                if [[ -f ../../ORCHIDEE/src_xml/context_input_orchidee.xml ]]; then
794                       cp ../../ORCHIDEE/src_xml/context_input_orchidee.xml .
795                       echo '<context id="orchidee" src="./context_input_orchidee.xml"/>' >> add.tmp
796                fi
797                sed -e '/id="LMDZ"/r add.tmp' iodef.xml > tmp
798                mv tmp iodef.xml
799                sed -e'{/sechiba1/ s/enabled="_AUTO_"/type="one_file" enabled=".TRUE."/}' \
800                    file_def_orchidee.xml > tmp
801                \mv -f tmp file_def_orchidee.xml
802                sed -e 's@enabled="_AUTO_"@type="one_file" enabled=".FALSE."@' \
803                    file_def_orchidee.xml > tmp
804                \mv -f tmp file_def_orchidee.xml
805                sed -e 's@output_level="_AUTO_"@output_level="1"@' \
806                    file_def_orchidee.xml > tmp
807                \mv -f tmp file_def_orchidee.xml
808                sed -e 's@output_freq="_AUTO_"@output_freq="1d"@' \
809                    file_def_orchidee.xml > tmp
810                \mv -f tmp file_def_orchidee.xml
811                sed -e 's@compression_level="4"@compression_level="0"@' \
812                    file_def_orchidee.xml > tmp
813                \mv -f tmp file_def_orchidee.xml
814                sed -e 's@XIOS_ORCHIDEE_OK = n@XIOS_ORCHIDEE_OK = y@' \
815                    orchidee.def > tmp
816                \mv -f tmp orchidee.def
817            fi
818        fi
819
820        if [[ -f ../arch.env ]]; then source ../arch.env; fi
821
822        echo "EXECUTION DU BENCH"
823        date
824        if (! ./bench.sh > out.bench 2>&1) || ! (tail -n 1 listing | grep "Everything is cool"); then
825            tail listing
826            echo "Bench FAILED, exiting"; exit 1
827        fi
828        date
829        tail listing
830    fi
831
832    # 1D case
833    if [[ $SCM = 1 ]]; then
834        cd "$MODEL"
835        myget 1D/1D.tar.gz
836        tar xf 1D.tar.gz
837        cd 1D
838        if [[ $rad = "oldrad" ]]; then
839            sed -i'' -e 's/^rad=.*$/rad=oldrad/' run.sh
840            sed -i'' -e 's/^rad=.*$/rad=oldrad/' bin/compile
841        fi
842        echo "Running 1D/run.sh, log in $(pwd)/run1d.log"
843        ./run.sh > "$(pwd)/run1d.log" 2>&1
844    fi
845}
846
847echo "install_lmdz.sh DEBUT $(date)"
848
849set_default_params
850read_cmdline_args "$@"
851#download_model
852download_model_AMAURY
853init_arch
854check_available_software
855install_netcdf
856install_IOIPSL
857install_XIOS
858compile_orchidee
859compile_lmdz
860run_bench
Note: See TracBrowser for help on using the repository browser.